/* apccomm_all.h
   Part of "APCComm" 
   Copyright (C) 2000 Ralf Hoffmann
   Contact: ralf.hoffmann@epost.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
*/

#ifndef APCCOMM_ALL_H
#define APCCOMM_ALL_H

#define MAJOR 1
#define MINOR 1
#define PATCH 0

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef USE_OPEN
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <fcntl.h> 
  #ifndef AMIGA
    #include <unistd.h>
  #endif
#endif

#define TRANSFERBLOCKSIZE 1024

extern unsigned char *outblock,*inblock;

void transferblock();

typedef struct pc_file_tag {
#ifdef USE_OPEN
  int fp;
#else
  FILE *fp;
#endif
  int size;
  int checksum;
} pc_file_t;

extern pc_file_t outfile;
extern pc_file_t infile;

int init_outgoing_file(char*name);
void close_outgoing_file();
int init_incoming_file(char*name);
void close_incoming_file();

void putint(unsigned char *buffer,int value);
int getint(unsigned char *buffer);
int readtobuffer(unsigned char* buffer,int maxsize,int *return_checksum);
int writefrombuffer(unsigned char *buffer,int size,int *return_checksum);
int init_transferblocks();

#endif

