/* apccomm_am.c
   Part of "APCComm" 
   Copyright (C) 2000 Ralf Hoffmann
   Contact: ralf.hoffmann@epost.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
*/

#include "apccomm_am.h"

#define DDRA 0xbfd200
#define DDRB 0xbfe301
#define PRA 0xbfd000
#define PRB 0xbfe101
#define ICR 0xbfed01

unsigned char *icr=(unsigned char*)ICR;
unsigned char *prb=(unsigned char*)PRB;
unsigned char *pra=(unsigned char*)PRA;
unsigned char *ddrb=(unsigned char*)DDRB;
unsigned char *ddra=(unsigned char*)DDRA;

int lastvalue;

int getack()
{
  unsigned char v;
  v=*pra;
  lastvalue=v&3;
  return ((v&4)==0)?0:1;
}

int getvalue()
{
  getack();
  return lastvalue;
}

void setack(int value)
{
  unsigned char v;
  v=*prb;
  if(value==0) v&=0xf;
  else v|=0x10;
  *prb=v;
}

void putnibble(int value)
{
  unsigned char v,nv,ack;
  v=*prb;
  ack=v&0x10;
  nv=value;
  nv|=ack;
  *prb=nv;
}

void putnibbleack(int value,int ack)
{
  unsigned char v;
  v=value;
  v|=ack<<2;
  *prb=v;
}

void synchro()
{
  int count;
  setack(1);
  putnibble(0);
/*  while(getack()!=0);*/
  for(count=0;getack()!=0;count++) {
    Delay(1);
    if(count%25==0) {
      printf(".");
      fflush(stdout);
    }
  }
  putnibble(1);
/*  while(getvalue()!=1);*/
  for(count=0;getvalue()!=1;count++) {
    Delay(1);
    if(count%25==0) {
      printf(".");
      fflush(stdout);
    }
  }
  putnibble(2);
/*  while(getvalue()!=2);*/
  for(count=0;getvalue()!=2;count++) {
    Delay(1);
    if(count%25==0) {
      printf(".");
      fflush(stdout);
    }
  }
  setack(1);
}

