/* apccomm_pc.c
   Part of "APCComm" 
   Copyright (C) 2000 Ralf Hoffmann
   Contact: ralf.hoffmann@epost.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
*/

#include "apccomm_pc.h"

int amiga_nibble;
int ack;

void setack(int value)
{
  change_pin(LP_PIN[3],(value==1)?LP_SET:LP_CLEAR);
}

int getack()
{
  ack=(pin_is_set(LP_PIN11)==0)?0:1;
  return ack;
}

int getnibble()
{
  int i,i2;
/*  i=(pin_is_set(LP_PIN10)==0)?0:8;
  i|=(pin_is_set(LP_PIN12)==0)?0:4;
  i|=(pin_is_set(LP_PIN13)==0)?0:2;
  i|=(pin_is_set(LP_PIN15)==0)?0:1;
  amiga_nibble=i;
  return i;*/
  i=pin_is_set(LP_PIN10|LP_PIN12|LP_PIN13|LP_PIN15);
  if(i&LP_PIN10) i2=8; else i2=0;
  if(i&LP_PIN12) i2|=4;
  if(i&LP_PIN13) i2|=2;
  if(i&LP_PIN15) i2|=1;
  amiga_nibble=i2;
  return i2;
}

void putvalue(int value)
{
  if(value==3) set_pin(LP_PIN06|LP_PIN04);
  else if(value==0) clear_pin(LP_PIN06|LP_PIN04);
  else {
    change_pin(LP_PIN06,(value&1)?LP_SET:LP_CLEAR);
    change_pin(LP_PIN04,(value&2)?LP_SET:LP_CLEAR);
  }
}

void synchro()
{
  int count;
  setack(1);
  putvalue(0);
/*  while(getack()!=1);*/
  for(count=0;getack()!=1;count++) {
    usleep(1000);
    if(count%100==0) {
      printf(".");
      fflush(stdout);
    }
  }
  setack(0);
/*  while(getnibble()!=1);*/
  for(count=0;getnibble()!=1;count++) {
    usleep(1000);
    if(count%100==0) {
      printf(".");
      fflush(stdout);
    }
  }
  putvalue(1);
/*  while(getnibble()!=2);*/
  for(count=0;getnibble()!=2;count++) {
    usleep(1000);
    if(count%100==0) {
      printf(".");
      fflush(stdout);
    }
  }
  putvalue(2);
  setack(1);
}

void transferblock()
{
  int i,s1;
  int outbyte=0,inbyte,bytecyc,ti;

  bytecyc=3;
  for(i=0;i<TRANSFERBLOCKSIZE;i++) {
    s1=0;
    if(bytecyc==3) outbyte=outblock[i>>1];
    s1=outbyte>>((bytecyc--)*2);
    while(getack()!=0);
    putvalue(s1&0x3);
    inbyte=getnibble();
    setack(0);
    s1=outbyte>>((bytecyc--)*2);
    while(getack()!=1);
    putvalue(s1&0x3);
    ti=getnibble();
    ti<<=4;
    inbyte|=ti;
    setack(1);
    if(bytecyc<0) bytecyc=3;
    inblock[i]=(unsigned char)inbyte;
  }
}

